import java.util.*;
import java.io.*;

import org.jivesoftware.smack.Chat;
import org.jivesoftware.smack.ConnectionConfiguration;
import org.jivesoftware.smack.MessageListener;
import org.jivesoftware.smack.Roster;
import org.jivesoftware.smack.RosterEntry;
import org.jivesoftware.smack.XMPPConnection;
import org.jivesoftware.smack.XMPPException;
import org.jivesoftware.smack.SASLAuthentication;
import org.jivesoftware.smack.sasl.*;
import org.jivesoftware.smack.packet.Message;


public class XmppServConnection implements MessageListener{

    XMPPConnection connection;

    public void login(String userName, String password) throws XMPPException,IOException
    {
    ConnectionConfiguration config = new ConnectionConfiguration("10.1.21.22", 5222);
	connection = new XMPPConnection(config);

    connection.connect();
	//SASLAuthentication.supportSASLMechanism("EXTERNAL");
	SASLAuthentication sas = connection.getSASLAuthentication();
	sas.authenticate(userName, password, "");
	
	/* try {
            connection.login(userName, password);
            System.out.println("Logged in as " + connection.getUser());
            
           /*Presence presence = new Presence(Presence.Type.available);
            connection.sendPacket(presence);*/
            
        } catch (XMPPException ex) {
            //ex.printStackTrace();
            System.out.println("Failed to log in as " + connection.getUser());
            System.exit(1);
        }
*/
	
	
	connection.login(userName, password);
    }

    public void sendMessage(String message, String to) throws XMPPException
    {
    Chat chat = connection.getChatManager().createChat(to, this);
    chat.sendMessage(message);
    }

    public void displayBuddyList()
    {
    Roster roster = connection.getRoster();
    Collection<RosterEntry> entries = roster.getEntries();

    System.out.println("\n\n" + entries.size() + " buddy(ies):");
    for(RosterEntry r:entries)
    {
    System.out.println(r.getUser());
    }
    }

    public void disconnect()
    {
    connection.disconnect();
    }

    public void processMessage(Chat chat, Message message)
    {
    if(message.getType() == Message.Type.chat)
    System.out.println(chat.getParticipant() + " says: " + message.getBody());
    }

    public static void main(String args[]) throws XMPPException, IOException
    {
    // declare variables
    System.setProperty("smack.debugEnabled", "true");
    //XMPPConnection.DEBUG_ENABLED = true;

	XmppServConnection c = new XmppServConnection();
    BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    String msg;

    // System.out.print("1");
    // turn on the enhanced debugger
    XMPPConnection.DEBUG_ENABLED = true;


    // Enter your login information here
    c.login("anal@dnaindia.net", "123456");

    c.displayBuddyList();
    
    System.out.println("-----");
    
    System.out.println("Who do you want to talk to? - Type contacts full email address:");
    String talkTo = br.readLine();
    
    System.out.println("-----");
    System.out.println("All messages will be sent to " + talkTo);
    System.out.println("Enter your message in the console:");
    System.out.println("-----\n");

    while( !(msg=br.readLine()).equals("bye"))
    {
        c.sendMessage(msg, talkTo);
    }

    c.disconnect();
    System.exit(0);
    }

}